/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __maya_SurfaceAccessibleMaya_h__
#define __maya_SurfaceAccessibleMaya_h__

namespace fe
{

/**************************************************************************//**
    @brief Maya Surface Binding

	@ingroup maya
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessibleMaya:
	public SurfaceAccessibleBase
{
	public:
								SurfaceAccessibleMaya(void)					{}
virtual							~SurfaceAccessibleMaya(void)				{}

								//* as SurfaceAccessibleI
virtual	void					bind(Instance a_instance)
								{	setMeshData(
											a_instance.cast<MDataHandle>()); }
virtual	BWORD					isBound(void)
								{	return !m_meshData.asMesh().isNull(); }

virtual sp<SurfaceAccessorI>	accessor(SurfaceAccessibleI::Element a_element,
										String a_name,
										SurfaceAccessibleI::Creation a_create)
								{
									sp<SurfaceAccessorMaya> spAccessor(
											new SurfaceAccessorMaya);
									spAccessor->setMaster(registry()->master());
									spAccessor->setMeshData(m_meshData);
									if(spAccessor->bind(a_element,a_name) ||
											a_create==
											SurfaceAccessibleI::e_createMissing)
									{
										spAccessor->setSurfaceAccessible(
												sp<SurfaceAccessibleI>(this));
										return spAccessor;
									}
									return sp<SurfaceAccessorI>(NULL);
								}

virtual sp<SurfaceAccessorI>	accessor(SurfaceAccessibleI::Element a_element,
										SurfaceAccessibleI::Attribute
										a_attribute,
										SurfaceAccessibleI::Creation a_create)
								{
									sp<SurfaceAccessorMaya> spAccessor(
											new SurfaceAccessorMaya);
									spAccessor->setMaster(registry()->master());
									spAccessor->setMeshData(m_meshData);
									if(spAccessor->bind(a_element,a_attribute)
											|| a_create==
											SurfaceAccessibleI::e_createMissing)
									{
										spAccessor->setSurfaceAccessible(
												sp<SurfaceAccessibleI>(this));
										return spAccessor;
									}
									return sp<SurfaceAccessorI>(NULL);
								}

virtual	sp<SurfaceI>			surface(String a_group);

								//* TODO
/*
virtual	sp<SurfaceI>			subSurface(U32 a_subIndex,String a_group);
*/

virtual	void					append(sp<SurfaceAccessibleI>
										a_spSurfaceAccessibleI,
										const SpatialTransform& a_rTransform);

virtual	void					instance(sp<SurfaceAccessibleI>
										a_spSurfaceAccessibleI,
										const std::vector<SpatialTransform>&
										a_rTransformArray);

								//* Maya specific
		void					setMeshData(const MDataHandle a_meshData)
								{
									m_meshData=a_meshData;
									m_spSurfaceI=NULL;
								}
const	MDataHandle				meshData(void)
								{	return m_meshData; }

	private:
		sp<SurfaceI>	m_spSurfaceI;

		MDataHandle		m_meshData;
};

} // namespace

#endif /* __maya_SurfaceAccessibleMaya_h__ */
